(let

(do listener (listen 5 5813)

 (letrec 

  (fork 
    (accept) 
    (handle (cons (fopen 0 nil) (fopen 1 nil))) 
  )

  (accept lambda()
    (do socket (recv listener)
        (fork (accept) (handle socket))))

  (handle lambda(socket)
    (let
       (letrec
          (shell nil input output syspipe err_handler)
          (err_handler lambda(nSEC)
            (shell nSEC input output syspipe err_handler)))
       (input  car socket) 
       (output cdr socket)
       (syspipe cons nil nil)
    ))     
     
))

(shell lambda (nSEC input output syspipe err_handler)
(inLib compiler

 (letrec 

  (if (null nSEC) 
      (sh_loop)
      (seq (show_err)
           (sh_loop)))

  (show_err lambda()
     (seq (send  (quote Runtime_error:) output)
     (seq (sendc 32 output)
     (seq (send  (car nSEC) output)        
     (seq (sendc 10 output)
          (quote OK)))))
  )

  (sh_loop lambda()
   (seq (send (quote SEC>) output)
   (do e (read input)
   (do r (eval e)
   (seq (print r (quote secd))
        (sh_loop)
  )))))
     
  (self env)

  (comp_lsp lambda (fn)
    (comp_lex fn (car self)))

  (eval lambda(e)
    (do body (errch_comp e (car self))
    (seq (print body (quote secd))
    (do closure (cdr self)
       ((cons body closure)) ))))       

  (exec lambda(fn)
    (do body (force (ReadSFrom (f2name fn (quote sec))))
    (do closure (cdr self)
        ((cons body closure)) )))

  (comp_lex lambda (fn scope)
    (WriteSTo
      (errch_comp (ReadSFrom (f2name fn (quote lsp))) scope)
      (quote secd)
      (f2name fn (quote sec))
    ))

  (comp_self lambda()
    (seq (comp_lex (quote miniOS) nil)
         (quote OK)))

  (errch_comp lambda(e scope)
    (fork 
      (recv syspipe) 
      (do code 
        (force (comp e (if (null scope) nil (cons nil scope)) nil))
      (seq (send code syspipe) (fail 0)))
    ))

))))
