(letrec compile
  (compile lambda (e)
    (comp e nil (quote 
      (#rec
       #app 
       #dum
       #ldf
         (#ld_0_0 #rec #node
          #trsel
            (#ld_0_0 #cdr #rec #ld_1_0 #app_1
             #ld_0_0 #car #rec #ld_1_0 #app_1
             #cons #rtn)
          #ld_0_0 #trrec)
       #letrec_1 (#ld_0_0 #rtn)
       #app_1
       #stop)
    )))

  (comp lambda (e n c)
    (if (atom e)
        (cons (add #ld (location e n)) c)
    (if (integer e)
        (cons #ldc (cons e c))
    (if (eq e nil)
        (cons #ldc (cons e c))
    (let 
        (if (atom he)
            (if (lexleq he (quote inc))
                (if (lexleq he (quote cons))
                    (comp_00 he te n c)
                    (comp_01 he te n c) ) 
                (if (lexleq he (quote lexleq))
                    (comp_10 he te n c)
                    (comp_11 he te n c) ) ) 
            (comp_user he te n c))    
        (he car e)
        (te cdr e))  
  ))))

  (comp_00 lambda (he te n c)
    (if (eq he (quote cons))
        (comp_del (car (cdr te)) n
                  (comp_del (car te) n (cons_rec #cons c)))
    (comp1 
      he te n c 
      (test_cod he (quote ( (car.#car) (cdr.#cdr) (atom.#atom) )))
      (test_cod he (quote ( (add.#add) )))
  )))
  
  (comp_01 lambda (he te n c)
    (if (eq he (quote if))
        (let (comp_rec 
                     (car te) n
                     (if (eq #rtn (car c))
                         (cons #trsel (cons thenpt elsept))
                         (cons #sel (cons thenpt (cons elsept c))))
                     nil)    
          (thenpt comp (car (cdr te))       n (quote (#rtn)) ) 
          (elsept comp (car (cdr (cdr te))) n (quote (#rtn)) ))
    (comp1 
      he te n c 
      (test_cod he (quote ( (inc.#inc) (dec.#dec) )))
      (test_cod he (quote ( (eq.#eq) (div.#div) )))
  )))

  (comp_10 lambda (he te n c)
    (if (eq he (quote lambda))
        (let (cons #ldf (cons body c))
             (body comp 
                 (car (cdr te)) 
                 (cons (car te) n)
                 (quote (#rtn))))
    (if (eq he (quote let   )) (comp_block he te n c #let   )             
    (if (eq he (quote letrec)) (comp_block he te n c #letrec)             
    (comp1 
      he te n c 
      (test_cod he (quote ( (integer.#int) )))
      (test_cod he (quote ( (leq.#leq) (lexleq.#lexleq) )))
  )))))

  (comp_11 lambda (he te n c)
    (if (eq he (quote quote))
        (cons #ldc (cons (car te) c))
    (comp1 
      he te n c 
      (test_cod he (quote ( (null.#null) (node.#node) )))
      (test_cod he (quote ( (sub.#sub)   (mul.#mul) (rem.#rem) )))
  )))

  (comp1 lambda (he te n c i_1 i_2)
    (if (integer i_1) (comp_rec (car te) n (cons_rec i_1 c) 1)
    (if (integer i_2) (comp_rec (car te) n 
                      (comp_rec (car (cdr te)) n (cons_rec i_2 c) 2) nil)
    (comp_user he te n c)
  )))

  (comp_block lambda(he te n c i_let)
        (let (let (let (let
                           (if (eq he (quote let)) 
                               (complis args n block)
                               (cons #dum (complis args m block)))
                       (block if rtnok
                          (cons blhead body)
                          (cons blhead (cons body c)))) 
                  (body comp (car te) m (quote (#rtn))))
             (blhead if rtnok     
                        (add #ld (count args i_let))
                        (count args i_let)))
         (rtnok eq #rtn (car c))               
         (m cons (mapcar (lambda(x)(car x)) (cdr te)) n)
         (args mapcar (lambda(x)(cdr x)) (cdr te))))

  (comp_user lambda(he te n c)
    (complis te n 
         (comp_rec he n 
                  (if (eq #rtn (car c))
                      (cons (count te #trapp) nil)
                      (cons (count te #app) c))
                  3)))

  (cons_rec lambda(i c)
     (if (eq (car c) #rec)
         (if (eq i #car) (cons i c)
         (if (eq i #cdr) (cons i c) (cons i (cdr c))))
         (cons i c)))

  (comp_rec lambda(e n c tr) 
     (let
        (if (atom e) normal
        (if (integer e) reduced
        (if (eq e nil) reduced
        (if (eq (car e) (quote quote)) reduced 
        (if (eq (car e) (quote lambda)) reduced normal)))))
        (normal comp e n
           (if (null tr) (cons #rec c)
               (let
                  (if (eq i (div #trapp #ld)) 
                      (cons trval nil)
                      (if (eq r #rtn)
                          (cons (add #trrec i) nil)
                          (cons #rec c)) )
                  (trval  add #trrec (add 128 (sub (car c) #trapp)))
                  (i div (car c) #ld)
                  (r car (cdr c)) )))
        (reduced comp e n c) ))
            
  (comp_del lambda(e n c)   
     (let
        (if (node e)
            (if (eq (car e) (quote quote)) reduced 
            (if (eq (car e) (quote lambda)) reduced normal))
            reduced)
        (normal  cons #delay (cons (comp e n (quote (#rtn))) c))
        (reduced comp e n c) )) 
     
  (test_cod lambda (e n)
      (if (eq n nil) nil
          (if (eq e (car (car n))) 
              (cdr (car n))
              (test_cod e (cdr n)))))

  (member lambda (e n)
      (if (eq n nil) (quote f)
      (if (eq e (car n)) (quote t) (member e (cdr n)))))
  (posn lambda (e n)
      (if (eq e (car n)) 0 (inc (posn e (cdr n)))))

  (complis lambda (e n c)
    (if (eq e nil) c 
        (complis 
          (cdr e) n 
          (comp_del (car e) n c))))
          
  (count lambda(l i)
    (if (eq l nil) i
        (inc (count (cdr l) i))))
              
  (mapcar lambda(f l)
    (if (eq l nil) nil
        (cons (f (car l)) (mapcar f (cdr l)))))

  (location lambda (e n)
      (if (member e (car n)) 
          (posn e (car n))
          (add 256 (location e (cdr n)))))
    
)
