(lambda (input output syspipe)
(inLib compiler

 (letrec self

  (self env)

  (comp_lsp lambda (fn)
    (comp_lex fn (car self)))

  (eval lambda(e)
    (do body (errch_comp e (car self))
    (seq (print body (quote secd))
    (do closure (cdr self)
       ((cons body closure)) ))))       

  (exec lambda(fn)
    (do body (force (ReadSFrom (f2name fn (quote sec))))
    (do closure (cdr self)
        ((cons body closure)) )))

  (comp_lex lambda (fn scope)
    (WriteSTo
      (errch_comp (ReadSFrom (f2name fn (quote lsp))) scope)
      (quote secd)
      (f2name fn (quote sec))
    ))

  (comp_self lambda()
    (seq (comp_lex (quote rtl) nil)
    (seq (comp_lex (quote init) nil)
    (do rtl_cod (force (ReadSFrom (f2name (quote rtl) (quote sec))))
    (do rtl (((cons rtl_cod nil)))
    (seq (print (car rtl) (quote secd))
    (seq (comp_lex (quote shell) (car rtl))
        (quote OK))))))))

  (errch_comp lambda(e scope)
    (fork 
      (recv syspipe) 
      (do code 
        (force (comp e (if (null scope) nil (cons nil scope)) nil))
      (seq (send code syspipe) (fail 0)))
    ))

)))
