unit secd_msg;

interface

uses secd_mem;

procedure SendMsg;
procedure RecvMsg;
procedure ProcLoad;

{

 Port = <0|q0 q1> or <1|s' (e'.c')>
 
 SEND
 (Pipe msg s) e c --> ?

 RECV
 (Pipe s) e c --> ?

}

implementation

uses secd_cod, secd_str;

procedure ProcLoad;
 begin
  if Regs[r1].t=null then while Regs[r0].t=node do Roll(r0,r1);
  if Regs[r1].t=null 
   then Error('No pending process avialable')
   else begin
    Pop(r1,c);
    Pop(c,s);
    Pop(c,e);
   end;
 end;

procedure ProcSave;
 begin
  Push(e,c);
  Push(s,c);
  Push(c,r0); 
 end;

procedure SendMsg;
 begin
  Just(1);
  ProcSave; { Delay current process: r0 --> (((msg s) e c) r0) }
  ChCnt:=0;
  Pop(s,b); { a=Pipe, b:=msg } 
  case GetNodeP(a) of
   0:begin
      Car(a,w1);
      Push(b,w1);
      SetCar(a,w1);
      ProcLoad;
     end;
   1:begin
      Car(a,s);
      Cdr(a,c); Pop(c,e);
      SetAtom(w1,null,0);
      SetCar(a,w1); SetCdr(a,w1);
      SetNodeP(a,0);
      MoveReg(b,a);
      ChCnt:=1;
     end;
  end; 
 end;

procedure RecvMsg;
 begin
  Just(1);
  ChCnt:=0;
  case GetNodeP(a) of
   0:begin
      Car(a,b); Cdr(a,w1);
      if Regs[w1].t=null then while Regs[b].t=node do Roll(b,w1);
      if Regs[w1].t=null then begin
       Push(e,c);
       SetCar(a,s); SetCdr(a,c);
       SetNodeP(a,1);
       ProcLoad;
      end else begin
       SetCar(a,b); 
       Pop(w1,b);
       SetCdr(a,w1);
       MoveReg(b,a);
       ChCnt:=1;
      end;
     end;
   1:Error('Somebody wait on this pipe');
  end; 
 end;

end.

