(letrec compile
  (compile lambda (e)
    (comp e nil (quote (#app #stop))))

  (comp lambda (e n c)
    (if (atom e)
        (let (cons (add #ld (add (mul 256 (car tuple)) (cdr tuple))) c)
             (tuple location e n))
    (if (integer e)
        (cons #ldc (cons e c))
    (if (eq e nil)
        (cons #ldc (cons e c))
    (comp0 (car e) (cdr e) n c)))))


  (comp0 lambda (he te n c)
    (if (eq he (quote quote))
        (cons #ldc (cons (car te) c))
    (if (eq he (quote cons))
        (comp (car (cdr te)) n (comp (car te) n (cons #cons c)))
    (if (eq he (quote if))
        (let (comp 
               (car te) n
               (if (like (car c) #rtn)
                   (cons (add #trsel (rem (car c) 256)) (cons thenpt (cons elsept nil)))
                   (cons #sel (cons thenpt (cons elsept c)))
               )) 
          (thenpt comp (car (cdr te))       n (quote (#rtn)) ) 
          (elsept comp (car (cdr (cdr te))) n (quote (#rtn)) ))
    (if (eq he (quote lambda))
        (let (cons #ldf (cons body c))
          (body comp 
                 (car (cdr te)) 
                 (cons (car te) n)
                 (cons (add #rtn (count (car te) 0)) nil)))
    (comp1 
      he te n c 
      (test_cod he (quote ((let.#app) (letrec.#rap))))
      (test_cod he 
         (quote ((car.#car) (cdr.#cdr) (atom.#atom) (inc.#inc) (dec.#dec) (integer.#int))))
      (test_cod he 
         (quote ((eq.#eq) (add.#add) (sub.#sub) (mul.#mul) (div.#div) (rem.#rem) (leq.#leq))))
  ))))))

  (comp1 lambda (he te n c i_let i_1 i_2)
    (if (integer i_let)
        (let (let (let (let
                           (if (eq he (quote let)) 
                               (complis args n block)
                               (cons #dum (complis args m block)))
                       (block cons #ldf (cons body bltail))) 
                  (body comp (car te) m bdtail))
             (bltail if (like (car c) #rtn)
                        (cons (add (add #ld i_let) (count args (rem (car c) 256))) nil)
                        (cons i_let c))
             (bdtail if (like (car c) #rtn)
                        (quote (#rtn))  
                        (cons (add #rtn (count args 0)) nil) ))
         (m cons (mapcar (lambda(x)(car x)) (cdr te)) n)
         (args mapcar (lambda(x)(cdr x)) (cdr te)))
    (if (integer i_1) (comp (car te) n (cons i_1 c))
    (if (integer i_2) (comp (car te) n (comp (car (cdr te)) n (cons i_2 c)))
    (complis te n 
      (comp he n 
         (if (like (car c) #rtn)
             (cons (add #trapp (rem (car c) 256)) nil)
             (cons #app c)) )) 
  ))))

  (test_cod lambda (e n)
      (if (eq n nil) nil
          (if (eq e (car (car n))) 
              (cdr (car n))
              (test_cod e (cdr n)))))

  (like lambda (x y)
        (eq (div x #ld) (div y #ld)))

  (member lambda (e n)
      (if (eq n nil) (quote f)
      (if (eq e (car n)) (quote t) (member e (cdr n)))))
  (posn lambda (e n)
      (if (eq e (car n)) 0 (inc (posn e (cdr n)))))
  (incar lambda (l) (cons (inc (car l)) (cdr l)))

  (complis lambda (e n c)
    (if (eq e nil) c 
        (complis (cdr e) n (comp (car e) n c))))

  (count lambda(l i)
    (if (eq l nil) i
        (inc (count (cdr l) i))))
              
  (mapcar lambda(f l)
    (if (eq l nil) nil
        (cons (f (car l)) (mapcar f (cdr l)))))

  (location lambda (e n)
      (if (member e (car n)) (cons 0 (posn e (car n)))
          (incar (location e (cdr n))))
  )
    
)
